package net.lecnam.info;

import java.util.Arrays;

class BoundedStack {

	char[] elems;
	int top;

	// @invariant (top >= 0 && top <= elems.length);

	// @requires (capacity > 0);
	// @ensures (top == 0 && elems.length == capacity);
	BoundedStack(int capacity) {
		assert (capacity > 0);
		top = 0;
		elems = new char[capacity];
		assert (top == 0 && elems.length == capacity);
		assert (top >= 0 && top <= elems.length);
	}

	// @requires (size >= 0) && (size <= array.length);
	BoundedStack(char[] array, int size) {
		assert (size >= 0) && (size <= array.length);
		top = size;
		elems = array;
		assert (top >= 0 && top <= elems.length);
	}

	@Override
	public String toString() {
		return "BoundedStack [elems=" + Arrays.toString(elems) + ", top=" + top + "]";
	}

	// @requires (top > 0);
	// @ensures \result == elems[top - 1];
	char peek() {
		assert (top >= 0 && top <= elems.length);
		assert (top > 0);
		char result = elems[top - 1];
		assert result == elems[top - 1];
		assert (top >= 0 && top <= elems.length);
		return result;
	}

	// @requires (top < elems.length);
	// @ensures (top == \old (top) + 1) && elems[\old (top)] == item;
	void push(char item) {
		assert (top >= 0 && top <= elems.length);
		assert (top < elems.length);
		int old_top = top;
		elems[top] = item;
		top = top + 1;
		assert (top == old_top + 1) && elems[old_top] == item;
		assert (top >= 0 && top <= elems.length);
	}

	// @requires (top > 0);
	// @ensures (top == \old (top) - 1) && \result == elems[top];
	char pop() {
		int old_top = top;
		top = top - 1;
		char result = elems[top];
		return result;
	}

	// @ensures (\result == (top == elems.length));
	boolean isFull() {
		if (top == elems.length) {
			boolean result = true;
			return result;
		} else {
			boolean result = false;
			return result;
		}
	}

	// @ensures (\result == (top == 0));
	boolean isEmpty() {
		if (top == 0) {
			boolean result = true;
			return result;
		} else {
			boolean result = false;
			return result;
		}
	}
}