package net.lecnam.info;

import static net.lecnam.info.Arbitrary.*;
import static org.junit.jupiter.api.Assertions.*;
import static org.junit.jupiter.api.Assumptions.assumeTrue;

import java.util.stream.Stream;

import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.provider.Arguments;
import org.junit.jupiter.params.provider.MethodSource;

import net.lecnam.info.BoundedStack;

class BoundedStackTest {

	static int maxSize = 10;
	
	static BoundedStack arbitraryStack() {
		String content = arbitraryLowercaseString(maxSize);
		Integer top = arbitraryInteger(0, content.length());
		return new BoundedStack(content.toCharArray(), top);
	}
	
	@Test
	@Disabled
	void testBoundedStackInt() {
		fail("Not yet implemented");
	}

	@Test
	@Disabled
	void testBoundedStackCharArrayInt() {
		fail("Not yet implemented");
	}
	
	static String arbitraryLowercaseString(int bound) {
		return arbitraryString(() -> bound, () -> arbitraryLowercaseLetter());
	}

	static Stream<BoundedStack> testCaseProviderForPeek() {
		return Stream.generate(() -> arbitraryStack())
				.limit(20);
	}

	@ParameterizedTest
	@MethodSource("testCaseProviderForPeek")
	void testPeek(BoundedStack stack) {
		assumeTrue(stack.top >= 0 && stack.top <= stack.elems.length);
		assumeTrue(stack.top > 0);
		char result = stack.peek();
		assertTrue(result == stack.elems[stack.top - 1]);
		assertTrue(stack.top >= 0 && stack.top <= stack.elems.length);
	}

	static Arguments argumentsForPush() {
		return Arguments.of(arbitraryStack(), arbitraryLowercaseLetter());
	}

	static Stream<Arguments> testCaseProviderForPush() {
		return Stream.generate(() -> argumentsForPush()).limit(20);
	}

	@ParameterizedTest
	@MethodSource("testCaseProviderForPush")
	void testPush(BoundedStack stack , char item) {
		int old_top = stack.top;
		assumeTrue(stack.top >= 0 && stack.top <= stack.elems.length);
		assumeTrue(stack.top < stack.elems.length);
		stack.push(item);
		assertTrue(stack.top == old_top + 1 && stack.elems[old_top] == item);
		assertTrue(stack.top >= 0 && stack.top <= stack.elems.length);
	}

	@Test
	@Disabled
	void testPop() {
		fail("Not yet implemented");
	}

	@Test
	@Disabled
	void testIsFull() {
		fail("Not yet implemented");
	}

	@Test
	@Disabled
	void testIsEmpty() {
		fail("Not yet implemented");
	}

}
